package com.commonsware.android.hadentest;

import androidx.appcompat.app.AppCompatActivity;
import android.content.Context;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.nio.channels.FileChannel;

public class MainActivity extends AppCompatActivity {
  @Override
  protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.activity_main);

    getExternalFilesDir(null).mkdirs();

    findViewById(R.id.importMe).setOnClickListener(v -> copyFileIn(this));

    findViewById(R.id.exportMe).setOnClickListener(v -> copyFileOut(this));
  }

  public boolean copyFileOut(Context context)
  {
    try
    {
      File sd = context.getExternalFilesDir(null);
      String backupDBPath = "BEST/ProductDB/ProductData.db";
      File currentDB = context.getDatabasePath("ProductData.db");
      File backupDB = new File(sd, backupDBPath);

      backupDB.getParentFile().mkdirs();

      if (currentDB.exists()) {
        FileChannel src = new FileInputStream(currentDB).getChannel();
        FileChannel dst = new FileOutputStream(backupDB).getChannel();
        dst.transferFrom(src, 0, src.size());
        src.close();
        dst.close();
        System.out.println("Export successful");
        return true;
      } else {
        System.out.println("Can't find currentDBPath");
      }
    }
    catch (Exception e) {
      Log.w("Settings Backup", e);
    }
    return false;
  }

  public boolean copyFileIn(Context context)
  {
    try
    {
      File sd = context.getExternalFilesDir(null);
      String backupDBPath = "BEST/ProductDB/ProductData.db";
      File currentDB = context.getDatabasePath("ProductData.db");

      currentDB.getParentFile().mkdirs();

      File backupDB = new File(sd, backupDBPath);

      if (backupDB.exists()) {
        FileChannel src = new FileInputStream(backupDB).getChannel();
        FileChannel dst = new FileOutputStream(currentDB).getChannel();
        dst.transferFrom(src, 0, src.size());
        src.close();
        dst.close();
        System.out.println("Import successful");
        return true;
      } else {
        System.out.println("Can't find currentDBPath");
      }
    }
    catch (Exception e) {
      Log.w("Settings Backup", e);
    }
    return false;
  }
}